<?php

declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

final class CreateBrokerContacts extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change(): void
    {
        $this->execute('SET unique_checks=0; SET foreign_key_checks=0;');
        $this->execute("ALTER DATABASE CHARACTER SET 'utf8mb4';");
        $this->execute("ALTER DATABASE COLLATE='utf8mb4_general_ci';");

        $this->table('broker_contacts')
            ->addColumn('rut', 'integer', ['signed' => false, 'null' => true])
            ->addColumn('digit', 'string', ['length' => 1, 'null' => true])
            ->addColumn('name', 'string', ['length' => 255, 'null' => true])
            ->addColumn('email', 'string', ['length' => 255, 'null' => true])
            ->addColumn('phone', 'string', ['length' => 255, 'null' => true])
            ->addColumn('address_id', 'integer', ['signed' => false, 'null' => true])
            ->addForeignKey('address_id', 'direccion', ['id'], ['delete' => 'CASCADE', 'update' => 'CASCADE'])
            ->create();

        $this->execute('SET unique_checks=1; SET foreign_key_checks=1;');
    }
}
